
/* Relay bits masks
 */
#define	RELAY_NONE	0		/* All relays off		*/
#define	RELAY_CREF	1		/* Cref relay on		*/
#define	RELAY_CX	2		/* Cx relay on			*/
#define	RELAY_LX	4		/* Lx relay on			*/

/* Routines */
int calibrate(void);			/* Calibrate workhorse		*/
double measure_c(void);			/* Cx measurement workhorse	*/
double measure_l(void);			/* Lx measurement workhorse	*/
void measure_lc(double *, double *);	/* LCx measurement workhorse	*/

/* Utility routines */
void print_c(double);			/* Pretty print capacitance	*/
void print_l(double);			/* Pretty print inductance	*/
void print_f(double);			/* Pretty print frequency	*/

