/*
 * Comport test program COMTEST
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "global.h"
#include "cmdparse.h"

#define	LCMSTARTUP	"./lcm.cmd"

static char *Prompt = "lcm> ";

int doexit __ARGS((int argc,char *argv[],void *p));
int doecho __ARGS((int argc,char *argv[],void *p));
int dohelp __ARGS((int argc,char *argv[],void *p));
int dorelays __ARGS((int argc,char *argv[],void *p));
int dolpt __ARGS((int argc,char *argv[],void *p));
int dofreq __ARGS((int argc,char *argv[],void *p));
int doset __ARGS((int argc,char *argv[],void *p));
int dodisplay __ARGS((int argc,char *argv[],void *p));
int docal __ARGS((int argc,char *argv[],void *p));
int docx __ARGS((int argc,char *argv[],void *p));
int dolx __ARGS((int argc,char *argv[],void *p));
int dolcx __ARGS((int argc,char *argv[],void *p));
int doshowports __ARGS((int argc,char *argv[],void *p));

/* Command lookup and branch tables */
struct cmds Cmds[] = {
	"calibrate",	docal,	0,	"Calibrate L0 and C0", NULLCHAR,
	"cx",		docx,	0,	"Measure Cx",	NULLCHAR,
	"cx0",		docx,	0,	"Measure Cx",	NULLCHAR,
	"display",	dodisplay, 0,	"Display variables", NULLCHAR,
	"echo",		doecho, 0,	"Echo arguments", NULLCHAR,
	"exit",		doexit,	0,	"Exit program",	NULLCHAR,
	"frequency",	dofreq,	0,	"Measure frequency", NULLCHAR,
	"help",		dohelp,	0,	"Print help",	NULLCHAR,
	"lpt",		dolpt,	0,	"LPT 1|2|3",	NULLCHAR,
	"lcx",		dolcx,	0,	"Measure LCx",	NULLCHAR,
	"lx",		dolx,	0,	"Measure Lx",	NULLCHAR,
	"lx0",		dolx,	0,	"Measure Lx",	NULLCHAR,
	"relays",	dorelays,0,	"Relays 0-7",	NULLCHAR,
	"set",		doset,	0,	"Set variable",	NULLCHAR,
	"showports",	doshowports, 0,	"Show ports values", NULLCHAR,
	"?",		dohelp,	0,	"Print help",	NULLCHAR,
	NULLCHAR,	NULLFP, 0,	NULLCHAR,
				"Unknown command; type \"?\" for list"
};

main(argc,argv)
int argc;
char *argv[];
{
	char	inbuf[256];
	FILE	*cmdf;

	/* Read commands from startup command file */
	if ((cmdf = fopen(LCMSTARTUP,"r")) == NULL ) {
		fprintf(stderr,"No startup file\n");
	} else {
		while(fgets(inbuf,256,cmdf) != NULL) {
			rip(inbuf);
			if (strlen(inbuf) > 0)
				cmdparse(Cmds,inbuf,NULL);
		}
		fclose(cmdf);
	}

	/* Initialize */
/*
	if (i2c_init(lpt) < 0) {
		exit(1);
	}
*/
	
	/* Read commands from keyboard */
	for(;;) {
		printf(Prompt);
		fgets(inbuf,256,stdin);
		rip(inbuf);
		if (strlen(inbuf) > 0)
			cmdparse(Cmds,inbuf,NULL);
	}
}

int
donop(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	return(0);
}
  
int
doexit(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	exit(0);
	return(0);	/* to keep bcc happy !! */
}
  
int
doecho(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	if (argc == 1)
		printf("\n");
	else
		printf("%s\n",argv[1]);
	return(0);	/* to keep bcc happy !! */
}
  
int
dohelp(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	register struct cmds *cmdp;
	int i;
	char buf[256];
	char **pargv;
	FILE *fp;
  
	puts("Main commands:\n");
        for(cmdp = Cmds;cmdp->name != NULL;cmdp++){
		printf("%-12s: %s\n",cmdp->name,cmdp->helpmsg);
        }
	return 0;
}
  
